Index: /trunk/src/VBox/Main/src-server/MachineImpl.cpp
===================================================================
--- /trunk/src/VBox/Main/src-server/MachineImpl.cpp	(revision 60053)
+++ /trunk/src/VBox/Main/src-server/MachineImpl.cpp	(revision 60054)
@@ -9614,5 +9614,5 @@
         const ComObjPtr<MediumAttachment> &pAtt = *it;
         // should never happen, but deal with NULL pointers in the list.
-        AssertStmt(!pAtt.isNull(), continue);
+        AssertContinue(!pAtt.isNull());
 
         // getControllerName() needs caller+read lock
@@ -12135,5 +12135,5 @@
         MediumAttachment* pAttach = *it;
         /* just in case */
-        AssertStmt(pAttach, continue);
+        AssertContinue(pAttach);
 
         AutoCaller localAutoCallerA(pAttach);
Index: /trunk/src/VBox/Main/src-server/Performance.cpp
===================================================================
--- /trunk/src/VBox/Main/src-server/Performance.cpp	(revision 60053)
+++ /trunk/src/VBox/Main/src-server/Performance.cpp	(revision 60054)
@@ -1075,5 +1075,5 @@
 
         /* just in case */
-        AssertStmt(!pMedium.isNull(), continue);
+        AssertContinue(!pMedium.isNull());
 
         AutoCaller localAutoCaller(pMedium);
Index: /trunk/src/VBox/Runtime/generic/http-curl.cpp
===================================================================
--- /trunk/src/VBox/Runtime/generic/http-curl.cpp	(revision 60053)
+++ /trunk/src/VBox/Runtime/generic/http-curl.cpp	(revision 60054)
@@ -1049,5 +1049,5 @@
 {
     CFStringRef hStrProxyType = (CFStringRef)CFDictionaryGetValue(hDictProxy, kCFProxyTypeKey);
-    AssertStmt(hStrProxyType, continue);
+    AssertContinue(hStrProxyType);
 
     /*
@@ -1160,5 +1160,5 @@
     {
         CFDictionaryRef hDictProxy = (CFDictionaryRef)CFArrayGetValueAtIndex(hArrayProxies, i);
-        AssertStmt(hDictProxy, continue);
+        AssertContinue(hDictProxy);
 
         rcRet = rtHttpDarwinTryConfigProxy(pThis, hDictProxy, hUrlTarget, fIgnorePacType);
@@ -1208,6 +1208,6 @@
         {
             CFStringRef hStr = (CFStringRef)CFArrayGetValueAtIndex(hArray, i);
-            AssertStmt(hStr, continue);
-            AssertStmt(CFStringGetCString(hStr, szTmp, sizeof(szTmp), kCFStringEncodingUTF8), continue);
+            AssertContinue(hStr);
+            AssertContinue(CFStringGetCString(hStr, szTmp, sizeof(szTmp), kCFStringEncodingUTF8));
             RTStrToLower(szTmp);
 
Index: /trunk/src/VBox/Runtime/r3/darwin/RTCrStoreCreateSnapshotById-darwin.cpp
===================================================================
--- /trunk/src/VBox/Runtime/r3/darwin/RTCrStoreCreateSnapshotById-darwin.cpp	(revision 60053)
+++ /trunk/src/VBox/Runtime/r3/darwin/RTCrStoreCreateSnapshotById-darwin.cpp	(revision 60054)
@@ -62,10 +62,10 @@
         {
             CFDictionaryRef hDict = (CFDictionaryRef)CFArrayGetValueAtIndex(hTrustSettings, i);
-            AssertStmt(CFGetTypeID(hDict) == CFDictionaryGetTypeID(), continue);
+            AssertContinue(CFGetTypeID(hDict) == CFDictionaryGetTypeID());
 
             CFNumberRef hNum = (CFNumberRef)CFDictionaryGetValue(hDict, kSecTrustSettingsResult);
             if (hNum)
             {
-                AssertStmt(CFGetTypeID(hNum) == CFNumberGetTypeID(), continue);
+                AssertContinue(CFGetTypeID(hNum) == CFNumberGetTypeID());
                 SInt32 iNum;
                 if (CFNumberGetValue(hNum, kCFNumberSInt32Type, &iNum))
Index: /trunk/src/VBox/Runtime/r3/win/process-win.cpp
===================================================================
--- /trunk/src/VBox/Runtime/r3/win/process-win.cpp	(revision 60053)
+++ /trunk/src/VBox/Runtime/r3/win/process-win.cpp	(revision 60054)
@@ -777,5 +777,5 @@
             uNew.TokPriv.PrivilegeCount = 1;
             uNew.TokPriv.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;
-            AssertStmt(LookupPrivilegeValue(NULL, s_aPrivileges[i].pszName, &uNew.TokPriv.Privileges[0].Luid), continue);
+            AssertContinue(LookupPrivilegeValue(NULL, s_aPrivileges[i].pszName, &uNew.TokPriv.Privileges[0].Luid));
             uOld = uNew;
             SetLastError(NO_ERROR);
@@ -1086,5 +1086,5 @@
     {
         PACE_HEADER pAceHdr;
-        AssertStmt(GetAce(pDstAcl, i, (PVOID *)&pAceHdr), continue);
+        AssertContinue(GetAce(pDstAcl, i, (PVOID *)&pAceHdr));
         if (   pAceHdr->AceSize == cbAllowedAce
             && memcmp(pAceHdr, &AceBuf.Core, cbAllowedAce) == 0)