Index: trunk/src/VBox/Main/testcase/tstVBoxMultipleVM.cpp
===================================================================
--- trunk/src/VBox/Main/testcase/tstVBoxMultipleVM.cpp	(revision 60169)
+++ trunk/src/VBox/Main/testcase/tstVBoxMultipleVM.cpp	(revision 60170)
@@ -49,7 +49,6 @@
 static volatile bool            g_RunTest = true;
 static RTSEMEVENT               g_PingEevent;
-static volatile uint64_t 	g_Counter = 0;
+static volatile uint64_t        g_Counter = 0;
 static RTTEST                   g_hTest;
-static Bstr                     tstMachineName = "tstVBoxMultipleVM test multiple VM start/stop";
 
 /* Arguments of test thread */
@@ -86,5 +85,5 @@
 
 
-static int tstStartVM(IVirtualBox* pVBox, ISession* pSession, Bstr machineID, BOOL skipUnlok)
+static int tstStartVM(IVirtualBox *pVBox, ISession *pSession, Bstr machineID, bool fSkipUnlock)
 {
     HRESULT rc;
@@ -98,5 +97,5 @@
     if(SUCCEEDED(rc))
         rc = machine->LaunchVMProcess(pSession, Bstr("headless").raw(),
-            Bstr("").raw(), progress.asOutParam());
+                                      Bstr("").raw(), progress.asOutParam());
     if (SUCCEEDED(rc) && !progress.isNull())
     {
@@ -119,24 +118,18 @@
                     }
                     else
-                    {
                         RTPrintf("VM '%ls' started.\n", machineName.raw());
-                    }
                 }
             }
         }
-        if (!skipUnlok)
-        {
+        if (!fSkipUnlock)
             pSession->UnlockMachine();
-        }
         else
-        {
             RTPrintf("Session unlock skipped.\n");
-        }
-    }
-    return rc;
-}
-
-
-static int tstStopVM(IVirtualBox* pVBox, ISession* pSession, Bstr machineID, BOOL skipUnlok)
+    }
+    return rc;
+}
+
+
+static int tstStopVM(IVirtualBox* pVBox, ISession* pSession, Bstr machineID, bool fSkipUnlock)
 {
     HRESULT rc;
@@ -151,5 +144,5 @@
         rc = TST_COM_EXPR(machine->COMGETTER(State)(&machineState));
     // check that machine is in running state
-    if (machineState == MachineState_Running
+    if (   machineState == MachineState_Running
         || machineState == MachineState_Paused)
     {
@@ -190,12 +183,8 @@
                 }
             }
-            if (!skipUnlok)
-            {
+            if (!fSkipUnlock)
                 pSession->UnlockMachine();
-            }
             else
-            {
                 RTPrintf("Session unlock skipped.\n");
-            }
         }
     }
@@ -205,8 +194,9 @@
 
 /**
-*   Get random maxCount machines from list of existing VMs
-*   Note: can return less then maxCount machines
-*/
-static int tstGetMachinesList(IVirtualBox *pVBox, uint32_t maxCount, TMachinesList& listToFill)
+ * Get random @a maxCount machines from list of existing VMs.
+ *
+ * @note Can return less then maxCount machines.
+ */
+static int tstGetMachinesList(IVirtualBox *pVBox, uint32_t maxCount, TMachinesList &listToFill)
 {
     HRESULT rc;
@@ -223,7 +213,7 @@
         if (machines[idx])
         {
-            Bstr strId;
+            Bstr bstrId;
             Bstr machineName;
-            CHECK_ERROR(machines[idx], COMGETTER(Id)(strId.asOutParam()));
+            CHECK_ERROR(machines[idx], COMGETTER(Id)(bstrId.asOutParam()));
             if (SUCCEEDED(rc))
                 CHECK_ERROR(machines[idx], COMGETTER(Name)(machineName.asOutParam()));
@@ -231,5 +221,5 @@
             {
                 if (Utf8Str(machineName).startsWith("umtvm"))
-                    listToFill.push_back(strId);
+                    listToFill.push_back(bstrId);
             }
         }
@@ -279,5 +269,5 @@
     // stop all machines in the pack
     for (TMachinesList::iterator it = machinesList.begin(); 
-	 it != machinesList.end() && g_RunTest;
+         it != machinesList.end() && g_RunTest;
          ++it)
     {
@@ -304,5 +294,5 @@
 
 
-static int tstCreateMachines(IVirtualBox* pVBox)
+static int tstCreateMachines(IVirtualBox *pVBox)
 {
     HRESULT rc;
@@ -334,5 +324,5 @@
 
 
-static int tstClean(IVirtualBox* pVBox, IVirtualBoxClient* pClient)
+static int tstClean(IVirtualBox *pVBox, IVirtualBoxClient *pClient)
 {
     HRESULT rc;
@@ -494,16 +484,14 @@
  * Examples:
  *   - tstVBoxClientWatcherLoad --packsize 500 --lock 10 --time 14400 --machines 4000
- *		It will create 4000 VMs with names "utmvm0"..."utmvm3999"
- *       It will start 500 random VMs together, stop them,
- *       without closing their session with probability 10%,
- *       will repeat this during 4 hours.
- * 		After test it will delete all "utmvm..." machines.
+ *     It will create 4000 VMs with names "utmvm0"..."utmvm3999".  It will start
+ *     500 random VMs together, stop them, without closing their session with
+ *     probability 10%, will repeat this over 4 hours.  After test it will
+ *     delete all "utmvm..." machines.
  *
  *   - tstVBoxClientWatcherLoad --packsize 1 --lock 30 --time 3600 --machines 1000
- * 		It will create 1000 VMs with names "utmvm0"..."utmvm999"
- *       It will start random VM - stop them,
- *       without closing their session with probability 30%,
- *       will repeat this during 30 minutes.
- * 		After test it will delete all "utmvm..." machines.
+ *     It will create 1000 VMs with names "utmvm0"..."utmvm999".  It will start
+ *     random VM - stop them, without closing their session with probability
+ *     30%, will repeat this over 30 minutes.  After test it will delete all
+ *     "utmvm..." machines.
  */
 int main(int argc, char **argv)
@@ -530,5 +518,5 @@
     RTPrintf("Arguments packSize = %d, percentUnlok = %d, time = %lld.\n",
              g_Args.machinesPackSize, g_Args.percentsUnlok, g_Args.cMsExecutionTime);
-		
+
     RTTHREAD hThread;
     rc = RTThreadCreate(&hThread, tstThreadRun, (void *)&g_Args,
@@ -565,5 +553,5 @@
     }
     RTSemEventDestroy(g_PingEevent);
-		
+
     com::Shutdown();
     if (RT_FAILURE(rc))